#!/bin/bash

set -x

echo "Iser Initiator : ****************** `hostname` ******************"

server1=192.168.1.57
scp -r -o StrictHostKeyChecking=no root@$server1:/root/cpu.text /root/

ls /root/cpu.text
if [ $? -ne 0 ];then
	echo '/root/cpu.text not exist'
	exit
fi

devices=`find /dev  -maxdepth 1 -type b -name "md*"`
for device in $devices;
do
        mdadm -S $device
done

ib1=192.168.17.57
ib0=192.168.18.57
date && iscsiadm -m discovery -t st -p $ib0 -I iser
if [ $? -ne 0 ]; then
	echo "date && iscsiadm -m discovery -t st -p $ib0 -I iser"
	exit 1;
fi 
for i in $(cat /root/cpu.text | grep 'spc-57' | grep "numa node \[0\]" | awk '{print $2}');
do
	date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib0 -I iser -l;
	if [ $? -ne 0 ]; then
		echo "date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib0 -I iser -l"
		exit 1;
	fi
done

sleep 2
date && iscsiadm -m discovery -t st -p $ib1 -I iser
if [ $? -ne 0 ]; then
	echo "date && iscsiadm -m discovery -t st -p $ib1 -I iser"
	exit 1;
fi
for i in $(cat /root/cpu.text | grep 'spc-57' | grep "numa node \[1\]" | awk '{print $2}');
do
	date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l;
	if [ $? -ne 0 ]; then
		echo "date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l"
		exit 1;
	fi
done


ib1=192.168.17.58
ib0=192.168.18.58
date && iscsiadm -m discovery -t st -p $ib0 -I iser
if [ $? -ne 0 ]; then
	echo "date && iscsiadm -m discovery -t st -p $ib0 -I iser"
	exit 1;
fi
for i in $(cat /root/cpu.text | grep 'spc-58' | grep "numa node \[0\]" | awk '{print $2}');
do
	date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib0 -I iser -l;
	if [ $? -ne 0 ]; then
		echo "date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l"
		exit 1;
	fi
done

sleep 2
date && iscsiadm -m discovery -t st -p $ib1 -I iser
for i in $(cat /root/cpu.text | grep 'spc-58' | grep "numa node \[1\]" | awk '{print $2}');
do
	date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l;
	if [ $? -ne 0 ]; then
		echo "date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l"
		exit 1;
	fi
done


ib1=192.168.17.59
ib0=192.168.18.59
date && iscsiadm -m discovery -t st -p $ib0 -I iser
if [ $? -ne 0 ]; then
	echo "date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l"
	exit 1;
fi
for i in $(cat /root/cpu.text | grep 'spc-59' | grep "numa node \[0\]" | awk '{print $2}');
do
	date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib0 -I iser -l;
	if [ $? -ne 0 ]; then
		echo "date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l"
		exit 1;
	fi
done

sleep 2
date && iscsiadm -m discovery -t st -p $ib1 -I iser
if [ $? -ne 0 ]; then
	echo "date && iscsiadm -m discovery -t st -p $ib1 -I iser"
	exit 1;
fi
for i in $(cat /root/cpu.text | grep 'spc-59' | grep "numa node \[1\]" | awk '{print $2}');
do
	date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l;
	if [ $? -ne 0 ]; then
		echo "date && iscsiadm -m node -T iqn.2001-04-1234.com.meidisen:pool.$i -p $ib1 -I iser -l"
	fi
done

sleep 4

devs=`ls -l /dev/disk/by-path/ | grep iscsi | grep asu | awk -F '/' '{print $NF}'`
for dev in $devs;
do
	echo 54 > /sys/block/$dev/device/queue_depth
	echo 1024 > /sys/block/$dev/queue/nr_requests
	echo 'noop' > /sys/block/$dev/queue/scheduler
	echo 128 > /sys/block/$dev/queue/max_sectors_kb
	echo 1 > /sys/block/$dev/queue/add_random
	echo 2 > /sys/block/$dev/queue/nomerges
done

devices=`find /dev  -maxdepth 1 -type b -name "md*"`
for device in $devices;
do
        mdadm -S $device
done

echo 'y' | mdadm --create /dev/md0 -c 32 -l 0 -n $(ls /dev/disk/by-path/ | grep 'asu1' | wc -l) $(ls /dev/disk/by-path/ | grep 'asu1' | sed -n 's/^/\/dev\/disk\/by-path\//p')
echo 'y' | mdadm --create /dev/md1 -c 32 -l 0 -n $(ls /dev/disk/by-path/ | grep 'asu2' | wc -l) $(ls /dev/disk/by-path/ | grep 'asu2' | sed -n 's/^/\/dev\/disk\/by-path\//p')
echo 'y' | mdadm --create /dev/md2 -c 32 -l 0 -n $(ls /dev/disk/by-path/ | grep 'asu3' | wc -l) $(ls /dev/disk/by-path/ | grep 'asu3' | sed -n 's/^/\/dev\/disk\/by-path\//p')

devices=`find /dev  -maxdepth 1 -type b -name "md*"`
for device in $devices;
do
        mdadm -D $device
done
